/* Example: global variables */
/* Like goto statements, global (external) variables may seem 
convenient, but experience shows they can cause many bugs. */

#include <stdio.h>

void func1(void);
void func2(void);

int g = 523;  /* global variable, visible throughout this file */


void main(void)
{
  extern int g;  /* not actually necessary, but good practice */
  
  printf("[main]:  g = %3i\n", g);
  g = 7;
  printf("[main]:  g = %3i\n", g);
  func1();
  printf("[main]:  g = %3i\n", g);
  return;
}


void func1(void)
{
  extern int g;      /* not actually necessary, but good practice */
  
  g += 100;
  printf("[func1]: g = %3i\n", g);
  func2();
  printf("[func1]: g = %3i\n", g);
  return;
}


void func2(void)
{
  extern int g;      /* not actually necessary, but good practice */
  
  g *= 2;
  printf("[func2]: g = %3i\n", g);
  return;
}
